Index: /trunk/src/sys/arch/pmax/include/sysconf.h
===================================================================
--- /trunk/src/sys/arch/pmax/include/sysconf.h	(revision 151)
+++ /trunk/src/sys/arch/pmax/include/sysconf.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sysconf.h,v 1.12 2008/01/03 23:02:24 joerg Exp $	*/
+/*	$NetBSD: sysconf.h,v 1.12.28.1 2010/12/24 07:23:41 matt Exp $	*/
 
 /*
@@ -66,10 +66,10 @@
 	 *	tc_init		-	initialize timecounters
 	 */
-	void	(*bus_reset) __P((void));
-	void	(*cons_init) __P((void));
-	void	(*iointr) __P((unsigned, unsigned, unsigned, unsigned));
-	void	(*intr_establish) __P((struct device *, void *, int,
-		    int (*)(void *), void *));
-	int	(*memsize) __P((void *));
+	void	(*bus_reset)(void);
+	void	(*cons_init)(void);
+	void	(*iointr)(uint32_t, vaddr_t, uint32_t);
+	void	(*intr_establish)(device_t, void *, int, int (*)(void *),
+		    void *);
+	int	(*memsize)(void *);
 	void	(*tc_init)(void);
 };
@@ -79,5 +79,5 @@
  */
 struct sysinit {
-	void	(*init) __P((void));
+	void	(*init)(void);
 	const char *option;
 };
@@ -87,11 +87,11 @@
 
 extern struct platform platform;
-extern struct sysinit sysinit[];
-extern int nsysinit;
+extern const struct sysinit sysinit[];
+extern const int nsysinit;
 
-int	memsize_scan __P((void *));
-int	memsize_bitmap __P((void *));
-void	platform_not_configured __P((void));
-void	platform_not_supported __P((void));
+int	memsize_scan(void *);
+int	memsize_bitmap(void *);
+void	platform_not_configured(void);
+void	platform_not_supported(void);
 
 #endif /* _KERNEL */
Index: /trunk/src/sys/arch/pmax/pmax/autoconf.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/autoconf.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/autoconf.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: autoconf.c,v 1.71 2007/12/03 15:34:09 ad Exp $	*/
+/*	$NetBSD: autoconf.c,v 1.71.36.1 2010/12/24 07:23:42 matt Exp $	*/
 
 /*
@@ -78,5 +78,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.71 2007/12/03 15:34:09 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.71.36.1 2010/12/24 07:23:42 matt Exp $");
 
 #include <sys/param.h>
@@ -115,8 +115,4 @@
 	(void)splhigh();
 
-	evcnt_attach_static(&pmax_clock_evcnt);
-	evcnt_attach_static(&pmax_fpu_evcnt);
-	evcnt_attach_static(&pmax_memerr_evcnt);
-
 	if (config_rootfound("mainbus", NULL) == NULL)
 		panic("no mainbus found");
@@ -126,5 +122,5 @@
 
 	/* Configuration is finished, turn on interrupts. */
-	_splnone();	/* enable all source forcing SOFT_INTs cleared */
+	spl0();	/* enable all source forcing SOFT_INTs cleared */
 }
 
Index: /trunk/src/sys/arch/pmax/pmax/bus_dma.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/bus_dma.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/bus_dma.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: bus_dma.c,v 1.49.16.2 2010/02/01 06:09:21 matt Exp $	*/
+/*	$NetBSD: bus_dma.c,v 1.49.16.3 2010/12/24 07:23:42 matt Exp $	*/
 
 /*-
@@ -32,5 +32,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: bus_dma.c,v 1.49.16.2 2010/02/01 06:09:21 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: bus_dma.c,v 1.49.16.3 2010/12/24 07:23:42 matt Exp $");
 
 #include "opt_cputype.h"
@@ -48,9 +48,9 @@
 #include <mips/cache.h>
 
-static int	_bus_dmamap_load_buffer __P((bus_dmamap_t,
+static int	_bus_dmamap_load_buffer(bus_dmamap_t,
 		    void *, bus_size_t, struct vmspace *, int, vaddr_t *,
-		    int *, int));
-
-paddr_t	kvtophys __P((vaddr_t));	/* XXX */
+		    int *, int);
+
+paddr_t	kvtophys(vaddr_t);	/* XXX */
 
 /*
@@ -737,5 +737,5 @@
 		if (curaddr < mips_avail_start || curaddr >= high) {
 			printf("uvm_pglistalloc returned non-sensical"
-			    " address 0x%lx\n", curaddr);
+			    " address 0x%"PRIxVADDR"\n", curaddr);
 			panic("_bus_dmamem_alloc");
 		}
Index: /trunk/src/sys/arch/pmax/pmax/dec_3100.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/dec_3100.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/dec_3100.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: dec_3100.c,v 1.44.36.1 2010/02/01 06:09:21 matt Exp $ */
+/* $NetBSD: dec_3100.c,v 1.44.36.3 2010/12/29 00:20:37 matt Exp $ */
 
 /*
@@ -105,16 +105,19 @@
  */
 
+#define __INTR_PRIVATE
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: dec_3100.c,v 1.44.36.1 2010/02/01 06:09:21 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: dec_3100.c,v 1.44.36.3 2010/12/29 00:20:37 matt Exp $");
 
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/device.h>
-
-#include <machine/cpu.h>
-#include <machine/intr.h>
+#include <sys/cpu.h>
+#include <sys/lwp.h>
+#include <sys/intr.h>
+
 #include <machine/sysconf.h>
 
 #include <mips/mips/mips_mcclock.h>	/* mcclock CPUspeed estimation */
+//#include <mips/locore.h>
 
 #include <dev/tc/tcvar.h>		/* tc_addr_t */
@@ -132,22 +135,25 @@
 #include "pm.h"
 
-void		dec_3100_init __P((void));		/* XXX */
-static void	dec_3100_bus_reset __P((void));
-
-static void	dec_3100_cons_init __P((void));
-static void	dec_3100_errintr __P((void));
-static void	dec_3100_intr __P((unsigned, unsigned, unsigned, unsigned));
-static void	dec_3100_intr_establish __P((struct device *, void *,
-		    int, int (*)(void *), void *));
-
-#define	kn01_wbflush()	mips1_wbflush() /* XXX to be corrected XXX */
-
-static const int dec_3100_ipl2spl_table[] = {
+void		dec_3100_init(void);		/* XXX */
+static void	dec_3100_bus_reset(void);
+
+static void	dec_3100_cons_init(void);
+static void	dec_3100_errintr(void);
+static void	dec_3100_intr(uint32_t, vaddr_t, uint32_t);
+static void	dec_3100_intr_establish(struct device *, void *,
+		    int, int (*)(void *), void *);
+
+#define	kn01_wbflush()	wbflush() /* XXX to be corrected XXX */
+
+static const struct ipl_sr_map dec_3100_ipl_sr_map = {
+    .sr_bits = {
 	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] = _SPL_SOFTCLOCK,
-	[IPL_SOFTSERIAL] = _SPL_SOFTSERIAL,
+	[IPL_SOFTCLOCK] = MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTSERIAL] = MIPS_SOFT_INT_MASK,
 	[IPL_VM] = MIPS_SPL_0_1_2,
-	[IPL_SCHED] = MIPS_SPL_0_1_2_3,
-	[IPL_HIGH] = MIPS_SPL_0_1_2_3,
+	[IPL_SCHED] = MIPS_SPLHIGH,
+	[IPL_DDB] = MIPS_SPLHIGH,
+	[IPL_HIGH] = MIPS_SPLHIGH,
+    }
 };
 
@@ -165,5 +171,5 @@
 	/* no high resolution timer available */
 
-	ipl2spl_table = dec_3100_ipl2spl_table;
+	ipl_sr_map = dec_3100_ipl_sr_map;
 
 	/* calibrate cpu_mhz value */
@@ -226,9 +232,5 @@
 
 static void
-dec_3100_intr(status, cause, pc, ipending)
-	unsigned status;
-	unsigned cause;
-	unsigned pc;
-	unsigned ipending;
+dec_3100_intr(uint32_t status, vaddr_t pc, uint32_t ipending)
 {
 	/* handle clock interrupts ASAP */
@@ -242,11 +244,5 @@
 		hardclock(&cf);
 		pmax_clock_evcnt.ev_count++;
-
-		/* keep clock interrupts enabled when we return */
-		cause &= ~MIPS_INT_MASK_3;
-	}
-
-	/* If clock interrupts were enabled, re-enable them ASAP. */
-	_splset(MIPS_SR_INT_IE | (status & MIPS_INT_MASK_3));
+	}
 
 	CALLINTR(SYS_DEV_SCSI, MIPS_INT_MASK_0);
@@ -258,15 +254,9 @@
 		pmax_memerr_evcnt.ev_count++;
 	}
-	_splset(MIPS_SR_INT_IE | (status & ~cause & MIPS_HARD_INT_MASK));
-}
-
-
-static void
-dec_3100_intr_establish(dev, cookie, level, handler, arg)
-	struct device *dev;
-	void *cookie;
-	int level;
-	int (*handler) __P((void *));
-	void *arg;
+}
+
+static void
+dec_3100_intr_establish(device_t dev, void *cookie, int level,
+	int (*handler)(void *), void *arg)
 {
 
Index: /trunk/src/sys/arch/pmax/pmax/dec_3max.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/dec_3max.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/dec_3max.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: dec_3max.c,v 1.45.36.1 2010/02/01 06:09:21 matt Exp $ */
+/* $NetBSD: dec_3max.c,v 1.45.36.3 2010/12/29 00:20:37 matt Exp $ */
 
 /*
@@ -105,15 +105,19 @@
  */
 
+#define	__INTR_PRIVATE
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: dec_3max.c,v 1.45.36.1 2010/02/01 06:09:21 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: dec_3max.c,v 1.45.36.3 2010/12/29 00:20:37 matt Exp $");
+
+#include "dzkbd.h"
 
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/device.h>
-
-#include <machine/cpu.h>
-#include <machine/bus.h>
-#include <machine/intr.h>
+#include <sys/lwp.h>
+#include <sys/cpu.h>
+#include <sys/bus.h>
+#include <sys/intr.h>
+
 #include <machine/locore.h>
 #include <machine/sysconf.h>
@@ -138,18 +142,21 @@
 static void	dec_3max_cons_init(void);
 static void	dec_3max_errintr(void);
-static void	dec_3max_intr(uint32_t, uint32_t, vaddr_t, uint32_t);
+static void	dec_3max_intr(uint32_t, vaddr_t, uint32_t);
 static void	dec_3max_intr_establish(device_t, void *,
 		    int, int (*)(void *), void *);
 
 
-#define	kn02_wbflush()	mips1_wbflush()	/* XXX to be corrected XXX */
-
-static const int dec_3max_ipl2spl_table[] = {
+#define	kn02_wbflush()	wbflush()	/* XXX to be corrected XXX */
+
+static const struct ipl_sr_map dec_3max_ipl_sr_map = {
+    .sr_bits = {
 	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] = _SPL_SOFTCLOCK,
-	[IPL_SOFTNET] = _SPL_SOFTNET,
+	[IPL_SOFTCLOCK] = MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] = MIPS_SOFT_INT_MASK,
 	[IPL_VM] = MIPS_SPL0,
-	[IPL_SCHED] = MIPS_SPL_0_1,
-	[IPL_HIGH] = MIPS_SPL_0_1,
+	[IPL_SCHED] = MIPS_SPLHIGH,
+	[IPL_DDB] = MIPS_SPLHIGH,
+	[IPL_HIGH] = MIPS_SPLHIGH,
+    },
 };
 
@@ -171,5 +178,5 @@
 	kn02_wbflush();
 
-	ipl2spl_table = dec_3max_ipl2spl_table;
+	ipl_sr_map = dec_3max_ipl_sr_map;
 
 	/* calibrate cpu_mhz value */
@@ -249,23 +256,19 @@
 
 static void
-dec_3max_intr_establish(dev, cookie, level, handler, arg)
-	device_t dev;
-	void *cookie;
-	int level;
-	int (*handler)(void *);
-	void *arg;
+dec_3max_intr_establish(device_t dev, void *cookie, int level,
+	int (*handler)(void *), void *arg)
 {
 	int i;
 	uint32_t csr;
 
-	for (i = 0; i < sizeof(kn02intrs)/sizeof(kn02intrs[0]); i++) {
-		if (kn02intrs[i].cookie == (int)cookie)
+	for (i = 0; i < __arraycount(kn02intrs); i++) {
+		if (kn02intrs[i].cookie == (intptr_t)cookie)
 			goto found;
 	}
-	panic("intr_establish: invalid cookie %d", (int)cookie);
+	panic("intr_establish: invalid cookie %p", cookie);
 
 found:
-	intrtab[(int)cookie].ih_func = handler;
-	intrtab[(int)cookie].ih_arg = arg;
+	intrtab[(intptr_t)cookie].ih_func = handler;
+	intrtab[(intptr_t)cookie].ih_arg = arg;
 
 	csr = *(uint32_t *)MIPS_PHYS_TO_KSEG1(KN02_SYS_CSR) & 0x00ffff00;
@@ -283,7 +286,7 @@
 
 static void
-dec_3max_intr(uint32_t status, uint32_t cause, vaddr_t pc, uint32_t ipending)
-{
-	static int warned = 0;
+dec_3max_intr(uint32_t status, vaddr_t pc, uint32_t ipending)
+{
+	static bool warned = false;
 	uint32_t csr;
 
@@ -294,8 +297,8 @@
 		csr = *(uint32_t *)MIPS_PHYS_TO_KSEG1(KN02_SYS_CSR);
 		if ((csr & KN02_CSR_PSWARN) && !warned) {
-			warned = 1;
+			warned = true;
 			printf("WARNING: power supply is overheating!\n");
 		} else if (warned && !(csr & KN02_CSR_PSWARN)) {
-			warned = 0;
+			warned = false;
 			printf("WARNING: power supply is OK again\n");
 		}
@@ -309,9 +312,5 @@
 
 		/* keep clock interrupts enabled when we return */
-		cause &= ~MIPS_INT_MASK_1;
-	}
-
-	/* If clock interrupts were enabled, re-enable them ASAP. */
-	_splset(MIPS_SR_INT_IE | (status & MIPS_INT_MASK_1));
+	}
 
 	if (ipending & MIPS_INT_MASK_0) {
@@ -339,6 +338,4 @@
 		pmax_memerr_evcnt.ev_count++;
 	}
-
-	_splset(MIPS_SR_INT_IE | (status & ~cause & MIPS_HARD_INT_MASK));
 }
 
@@ -352,5 +349,6 @@
 dec_3max_errintr()
 {
-	uint32_t erradr, errsyn, csr;
+	uint32_t erradr, csr;
+	vaddr_t errsyn;
 
 	/* Fetch error address, ECC chk/syn bits, clear interrupt */
Index: /trunk/src/sys/arch/pmax/pmax/dec_3maxplus.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/dec_3maxplus.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/dec_3maxplus.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: dec_3maxplus.c,v 1.58.28.1 2009/09/08 17:24:09 matt Exp $ */
+/* $NetBSD: dec_3maxplus.c,v 1.58.28.3 2010/12/29 00:20:37 matt Exp $ */
 
 /*
@@ -105,7 +105,8 @@
  */
 
+#define __INTR_PRIVATE
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: dec_3maxplus.c,v 1.58.28.1 2009/09/08 17:24:09 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: dec_3maxplus.c,v 1.58.28.3 2010/12/29 00:20:37 matt Exp $");
 
 #include <sys/param.h>
@@ -116,4 +117,5 @@
 #include <machine/cpu.h>
 #include <machine/sysconf.h>
+#include <machine/locore.h>
 
 #include <mips/mips/mips_mcclock.h>	/* mclock CPUspeed estimation */
@@ -133,13 +135,13 @@
 #include "wsdisplay.h"
 
-void		dec_3maxplus_init __P((void));		/* XXX */
-static void	dec_3maxplus_bus_reset __P((void));
-static void	dec_3maxplus_cons_init __P((void));
-static void 	dec_3maxplus_errintr __P((void));
-static void	dec_3maxplus_intr __P((unsigned, unsigned, unsigned, unsigned));
-static void	dec_3maxplus_intr_establish __P((struct device *, void *,
-		    int, int (*)(void *), void *));
-
-static void	kn03_wbflush __P((void));
+void		dec_3maxplus_init(void);		/* XXX */
+static void	dec_3maxplus_bus_reset(void);
+static void	dec_3maxplus_cons_init(void);
+static void 	dec_3maxplus_errintr(void);
+static void	dec_3maxplus_intr(uint32_t, vaddr_t, uint32_t);
+static void	dec_3maxplus_intr_establish(struct device *, void *,
+		    int, int (*)(void *), void *);
+
+static void	kn03_wbflush(void);
 
 static void	dec_3maxplus_tc_init(void);
@@ -151,8 +153,9 @@
 static unsigned latched_cycle_cnt;
 
-static const int dec_3maxplus_ipl2spl_table[] = {
-	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] = _SPL_SOFTCLOCK,
-	[IPL_SOFTNET] = _SPL_SOFTNET,
+static const struct ipl_sr_map dec_3maxplus_ipl_sr_map = {
+    .sr_bits = {
+	[IPL_NONE] =		0,
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,
 	/*
 	 * 3MAX+ IOASIC interrupts come through INT 0, while
@@ -160,7 +163,9 @@
 	 * should block IOASIC activities.
 	 */
-	[IPL_VM] = MIPS_SPL0,
-	[IPL_SCHED] = MIPS_SPL_0_1,
-	[IPL_HIGH] = MIPS_SPL_0_1,
+	[IPL_VM] =		MIPS_SOFT_INT_MASK | MIPS_INT_MASK_0,
+	[IPL_SCHED] =		MIPS_INT_MASK,
+	[IPL_DDB] =		MIPS_INT_MASK,
+	[IPL_HIGH] =		MIPS_INT_MASK,
+    },
 };
 
@@ -185,5 +190,5 @@
 	ioasic_base = MIPS_PHYS_TO_KSEG1(KN03_SYS_ASIC);
 
-	ipl2spl_table = dec_3maxplus_ipl2spl_table;
+	ipl_sr_map = dec_3maxplus_ipl_sr_map;
 
 	/* calibrate cpu_mhz value */
@@ -264,10 +269,6 @@
 
 static void
-dec_3maxplus_intr_establish(dev, cookie, level, handler, arg)
-	struct device *dev;
-	void *cookie;
-	int level;
-	int (*handler) __P((void *));
-	void *arg;
+dec_3maxplus_intr_establish(device_t dev, void *cookie, int level,
+	int (*handler)(void *), void *arg)
 {
 	unsigned mask;
@@ -314,5 +315,5 @@
     do {							\
 	if (can_serve & (bits)) {				\
-		ifound = 1;					\
+		ifound = true;					\
 		intrtab[vvv].ih_count.ev_count++;		\
 		(*intrtab[vvv].ih_func)(intrtab[vvv].ih_arg);	\
@@ -321,75 +322,32 @@
 
 static void
-dec_3maxplus_intr(status, cause, pc, ipending)
-	unsigned status;
-	unsigned cause;
-	unsigned pc;
-	unsigned ipending;
-{
-	static int warned = 0;
-	unsigned old_buscycle;
-
-	if (ipending & MIPS_INT_MASK_4)
-		prom_haltbutton();
-
-	/* handle clock interrupts ASAP */
-	old_buscycle = latched_cycle_cnt;
-	if (ipending & MIPS_INT_MASK_1) {
-		struct clockframe cf;
-
-		__asm volatile("lbu $0,48(%0)" ::
-			"r"(ioasic_base + IOASIC_SLOT_8_START));
-		cf.pc = pc;
-		cf.sr = status;
-		hardclock(&cf);
-		pmax_clock_evcnt.ev_count++;
-		old_buscycle = latched_cycle_cnt - old_buscycle;
-		/* keep clock interrupts enabled when we return */
-		cause &= ~MIPS_INT_MASK_1;
-	}
-
-	/* If clock interrupts were enabled, re-enable them ASAP. */
-	_splset(MIPS_SR_INT_IE | (status & MIPS_INT_MASK_1));
-
-#ifdef notdef
-	/*
-	 * Check for late clock interrupts (allow 10% slop). Be careful
-	 * to do so only after calling hardclock(), due to logging cost.
-	 * Even then, logging dropped ticks just causes more clock
-	 * ticks to be missed.
-	 */
-	if ((ipending & MIPS_INT_MASK_1) && old_buscycle > (tick+49) * 25) {
-		/* XXX need to include <sys/msgbug.h> for msgbufmapped */
-  		if (msgbufmapped && 0)
-			 addlog("kn03: clock intr %d usec late\n",
-				 old_buscycle/25);
-	}
-#endif
-	if (ipending & MIPS_INT_MASK_0) {
-		int ifound;
-		uint32_t imsk, intr, can_serve, xxxintr;
-
-		do {
-			ifound = 0;
-			imsk = *(uint32_t *)(ioasic_base + IOASIC_IMSK);
-			intr = *(uint32_t *)(ioasic_base + IOASIC_INTR);
-			can_serve = intr & imsk;
-
-			CHECKINTR(SYS_DEV_SCC0, IOASIC_INTR_SCC_0);
-			CHECKINTR(SYS_DEV_SCC1, IOASIC_INTR_SCC_1);
-			CHECKINTR(SYS_DEV_LANCE, IOASIC_INTR_LANCE);
-			CHECKINTR(SYS_DEV_SCSI, IOASIC_INTR_SCSI);
-			CHECKINTR(SYS_DEV_OPT2, KN03_INTR_TC_2);
-			CHECKINTR(SYS_DEV_OPT1, KN03_INTR_TC_1);
-			CHECKINTR(SYS_DEV_OPT0, KN03_INTR_TC_0);
-
-			if (warned > 0 && !(can_serve & KN03_INTR_PSWARN)) {
-				printf("%s\n", "Power supply ok now.");
-				warned = 0;
-			}
-			if ((can_serve & KN03_INTR_PSWARN) && (warned < 3)) {
-				warned++;
-				printf("%s\n", "Power supply overheating");
-			}
+dec_3maxplus_ioasic_intr(void)
+{
+	static bool warned = false;
+	bool ifound;
+	uint32_t imsk, intr, can_serve, xxxintr;
+
+	do {
+		ifound = false;
+		imsk = *(uint32_t *)(ioasic_base + IOASIC_IMSK);
+		intr = *(uint32_t *)(ioasic_base + IOASIC_INTR);
+		can_serve = intr & imsk;
+
+		CHECKINTR(SYS_DEV_SCC0, IOASIC_INTR_SCC_0);
+		CHECKINTR(SYS_DEV_SCC1, IOASIC_INTR_SCC_1);
+		CHECKINTR(SYS_DEV_LANCE, IOASIC_INTR_LANCE);
+		CHECKINTR(SYS_DEV_SCSI, IOASIC_INTR_SCSI);
+		CHECKINTR(SYS_DEV_OPT2, KN03_INTR_TC_2);
+		CHECKINTR(SYS_DEV_OPT1, KN03_INTR_TC_1);
+		CHECKINTR(SYS_DEV_OPT0, KN03_INTR_TC_0);
+
+		if (warned && !(can_serve & KN03_INTR_PSWARN)) {
+			printf("%s\n", "Power supply ok now.");
+			warned = false;
+		}
+		if ((can_serve & KN03_INTR_PSWARN) && (warned < 3)) {
+			warned = true;
+			printf("%s\n", "Power supply overheating");
+		}
 
 #define ERRORS	(IOASIC_INTR_SCSI_OVRUN|IOASIC_INTR_SCSI_READ_E|IOASIC_INTR_LANCE_READ_E)
@@ -412,11 +370,51 @@
 	 * non-DMA interrupts from ioctl devices or TC options.
 	 */
-			xxxintr = can_serve & (ERRORS | PTRLOAD);
-			if (xxxintr) {
-				ifound = 1;
-				*(uint32_t *)(ioasic_base + IOASIC_INTR)
-					= intr &~ xxxintr;
-			}
-		} while (ifound);
+		xxxintr = can_serve & (ERRORS | PTRLOAD);
+		if (xxxintr) {
+			ifound = true;
+			*(uint32_t *)(ioasic_base + IOASIC_INTR) = intr &~ xxxintr;
+		}
+	} while (ifound);
+}
+
+static void
+dec_3maxplus_intr(uint32_t status, vaddr_t pc, uint32_t ipending)
+{
+	unsigned old_buscycle;
+
+	if (ipending & MIPS_INT_MASK_4)
+		prom_haltbutton();
+
+	/* handle clock interrupts ASAP */
+	old_buscycle = latched_cycle_cnt;
+	if (ipending & MIPS_INT_MASK_1) {
+		struct clockframe cf;
+
+		__asm volatile("lbu $0,48(%0)" ::
+			"r"(ioasic_base + IOASIC_SLOT_8_START));
+		cf.pc = pc;
+		cf.sr = status;
+		hardclock(&cf);
+		pmax_clock_evcnt.ev_count++;
+		old_buscycle = latched_cycle_cnt - old_buscycle;
+		/* keep clock interrupts enabled when we return */
+	}
+
+#ifdef notdef
+	/*
+	 * Check for late clock interrupts (allow 10% slop). Be careful
+	 * to do so only after calling hardclock(), due to logging cost.
+	 * Even then, logging dropped ticks just causes more clock
+	 * ticks to be missed.
+	 */
+	if ((ipending & MIPS_INT_MASK_1) && old_buscycle > (tick+49) * 25) {
+		/* XXX need to include <sys/msgbug.h> for msgbufmapped */
+		if (msgbufmapped && 0)
+			 addlog("kn03: clock intr %d usec late\n",
+				 old_buscycle/25);
+	}
+#endif
+	if (ipending & MIPS_INT_MASK_0) {
+		dec_3maxplus_ioasic_intr();
 	}
 	if (ipending & MIPS_INT_MASK_3) {
@@ -424,6 +422,4 @@
 		pmax_memerr_evcnt.ev_count++;
 	}
-
-	_splset(MIPS_SR_INT_IE | (status & ~cause & MIPS_HARD_INT_MASK));
 }
 
Index: /trunk/src/sys/arch/pmax/pmax/dec_3min.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/dec_3min.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/dec_3min.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: dec_3min.c,v 1.60.22.2 2010/02/01 06:09:21 matt Exp $ */
+/* $NetBSD: dec_3min.c,v 1.60.22.4 2010/12/29 00:20:37 matt Exp $ */
 
 /*
@@ -105,7 +105,8 @@
  */
 
+#define	__INTR_PRIVATE
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: dec_3min.c,v 1.60.22.2 2010/02/01 06:09:21 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: dec_3min.c,v 1.60.22.4 2010/12/29 00:20:37 matt Exp $");
 
 #include <sys/param.h>
@@ -113,7 +114,8 @@
 #include <sys/device.h>
 #include <sys/timetc.h>
-
-#include <machine/cpu.h>
-#include <machine/intr.h>
+#include <sys/lwp.h>
+#include <sys/cpu.h>
+#include <sys/intr.h>
+
 #include <machine/sysconf.h>
 
@@ -134,12 +136,12 @@
 #include "wsdisplay.h"
 
-void		dec_3min_init __P((void));		/* XXX */
-static void	dec_3min_bus_reset __P((void));
-static void	dec_3min_cons_init __P((void));
-static void	dec_3min_intr __P((unsigned, unsigned, unsigned, unsigned));
-static void	dec_3min_intr_establish __P((struct device *, void *,
-		    int, int (*)(void *), void *));
-
-static void	kn02ba_wbflush __P((void));
+void		dec_3min_init(void);		/* XXX */
+static void	dec_3min_bus_reset(void);
+static void	dec_3min_cons_init(void);
+static void	dec_3min_intr(uint32_t, vaddr_t, uint32_t);
+static void	dec_3min_intr_establish(struct device *, void *,
+		    int, int (*)(void *), void *);
+
+static void	kn02ba_wbflush(void);
 
 static void	dec_3min_tc_init(void);
@@ -150,8 +152,9 @@
 static uint32_t kmin_tc3_imask;
 
-static const int dec_3min_ipl2spl_table[] = {
+static const struct ipl_sr_map dec_3min_ipl_sr_map = {
+    .sr_bits = {
 	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] = _SPL_SOFTCLOCK,
-	[IPL_SOFTNET] = _SPL_SOFTNET,
+	[IPL_SOFTCLOCK] = MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] = MIPS_SOFT_INT_MASK,
 	/*
 	 * Since all the motherboard interrupts come through the
@@ -160,7 +163,9 @@
 	 * TURBOchannel option slots, just splhigh().
 	 */
-	[IPL_VM] = MIPS_SPL_0_1_2_3,
-	[IPL_SCHED] = MIPS_SPL_0_1_2_3,
-	[IPL_HIGH] = MIPS_SPL_0_1_2_3,
+	[IPL_VM] = MIPS_SPLHIGH,
+	[IPL_SCHED] = MIPS_SPLHIGH,
+	[IPL_DDB] = MIPS_SPLHIGH,
+	[IPL_HIGH] = MIPS_SPLHIGH,
+    },
 };
 
@@ -182,5 +187,5 @@
 	ioasic_base = MIPS_PHYS_TO_KSEG1(KMIN_SYS_ASIC);
 
-	ipl2spl_table = dec_3min_ipl2spl_table;
+	ipl_sr_map = dec_3min_ipl_sr_map;
 
 	/* enable posting of MIPS_INT_MASK_3 to CAUSE register */
@@ -265,10 +270,6 @@
 
 static void
-dec_3min_intr_establish(dev, cookie, level, handler, arg)
-	struct device *dev;
-	void *cookie;
-	int level;
-	int (*handler) __P((void *));
-	void *arg;
+dec_3min_intr_establish(device_t dev, void *cookie, int level,
+	int (*handler)(void *), void *arg)
 {
 	unsigned mask;
@@ -355,127 +356,117 @@
 
 static void
-dec_3min_intr(status, cause, pc, ipending)
-	unsigned status;
-	unsigned cause;
-	unsigned pc;
-	unsigned ipending;
+dec_3min_intr(uint32_t status, vaddr_t pc, uint32_t ipending)
 {
 	static int user_warned = 0;
-	static int intr_depth = 0;
 	uint32_t old_mask;
 
-	intr_depth++;
 	old_mask = *(uint32_t *)(ioasic_base + IOASIC_IMSK);
 
-	if (ipending & MIPS_INT_MASK_4)
-		prom_haltbutton();
-
-	if (ipending & MIPS_INT_MASK_3) {
-		/* NB: status & MIPS_INT_MASK3 must also be set */
-		/* masked interrupts are still observable */
-		uint32_t intr, imsk, can_serve, turnoff;
-
-		turnoff = 0;
-		intr = *(uint32_t *)(ioasic_base + IOASIC_INTR);
-		imsk = *(uint32_t *)(ioasic_base + IOASIC_IMSK);
-		can_serve = intr & imsk;
-
-		if (intr & IOASIC_INTR_SCSI_PTR_LOAD) {
-			turnoff |= IOASIC_INTR_SCSI_PTR_LOAD;
+	do {
+		if (ipending & MIPS_INT_MASK_4)
+			prom_haltbutton();
+
+		if (ipending & MIPS_INT_MASK_3) {
+			/* NB: status & MIPS_INT_MASK3 must also be set */
+			/* masked interrupts are still observable */
+			uint32_t intr, imsk, can_serve, turnoff;
+
+			turnoff = 0;
+			intr = *(uint32_t *)(ioasic_base + IOASIC_INTR);
+			imsk = *(uint32_t *)(ioasic_base + IOASIC_IMSK);
+			can_serve = intr & imsk;
+
+			if (intr & IOASIC_INTR_SCSI_PTR_LOAD) {
+				turnoff |= IOASIC_INTR_SCSI_PTR_LOAD;
 #ifdef notdef
-			asc_dma_intr();
-#endif
+				asc_dma_intr();
+#endif
+			}
+
+			if (intr & (IOASIC_INTR_SCSI_OVRUN | IOASIC_INTR_SCSI_READ_E))
+				turnoff |= IOASIC_INTR_SCSI_OVRUN | IOASIC_INTR_SCSI_READ_E;
+
+			if (intr & IOASIC_INTR_LANCE_READ_E)
+				turnoff |= IOASIC_INTR_LANCE_READ_E;
+
+			if (turnoff)
+				*(uint32_t *)(ioasic_base + IOASIC_INTR) = ~turnoff;
+
+			if (intr & KMIN_INTR_TIMEOUT) {
+				kn02ba_errintr();
+				pmax_memerr_evcnt.ev_count++;
+			}
+
+			if (intr & KMIN_INTR_CLOCK) {
+				struct clockframe cf;
+
+				__asm volatile("lbu $0,48(%0)" ::
+					"r"(ioasic_base + IOASIC_SLOT_8_START));
+
+				cf.pc = pc;
+				cf.sr = status;
+				hardclock(&cf);
+				pmax_clock_evcnt.ev_count++;
+			}
+
+			/* If clock interrupts were enabled, re-enable them ASAP. */
+			if (old_mask & KMIN_INTR_CLOCK) {
+				/* ioctl interrupt mask to splclock and higher */
+				*(uint32_t *)(ioasic_base + IOASIC_IMSK) =
+				    old_mask &
+					~(KMIN_INTR_SCC_0|KMIN_INTR_SCC_1
+					  |IOASIC_INTR_LANCE|IOASIC_INTR_SCSI);
+				kn02ba_wbflush();
+			}
+
+			if (curcpu()->ci_idepth > 1)
+				 break;
+
+			CHECKINTR(SYS_DEV_SCC0, IOASIC_INTR_SCC_0);
+			CHECKINTR(SYS_DEV_SCC1, IOASIC_INTR_SCC_1);
+
+#ifdef notyet /* untested */
+			/* If tty interrupts were enabled, re-enable them ASAP. */
+			if ((old_mask & (KMIN_INTR_SCC_1|KMIN_INTR_SCC_0)) ==
+			     (KMIN_INTR_SCC_1|KMIN_INTR_SCC_0)) {
+				*imaskp = old_mask &
+				  ~(KMIN_INTR_SCC_0|KMIN_INTR_SCC_1 |
+				  IOASIC_INTR_LANCE|IOASIC_INTR_SCSI);
+				kn02ba_wbflush();
+			}
+
+			/* XXX until we know about SPLs of TC options. */
+			if (curcpu()->ci_idepth > 1)
+				 break;
+#endif
+			CHECKINTR(SYS_DEV_LANCE, IOASIC_INTR_LANCE);
+			CHECKINTR(SYS_DEV_SCSI, IOASIC_INTR_SCSI);
+
+			if (user_warned && ((intr & KMIN_INTR_PSWARN) == 0)) {
+				printf("%s\n", "Power supply ok now.");
+				user_warned = 0;
+			}
+			if ((intr & KMIN_INTR_PSWARN) && (user_warned < 3)) {
+				user_warned++;
+				printf("%s\n", "Power supply overheating");
+			}
 		}
-
-		if (intr & (IOASIC_INTR_SCSI_OVRUN | IOASIC_INTR_SCSI_READ_E))
-			turnoff |= IOASIC_INTR_SCSI_OVRUN | IOASIC_INTR_SCSI_READ_E;
-
-		if (intr & IOASIC_INTR_LANCE_READ_E)
-			turnoff |= IOASIC_INTR_LANCE_READ_E;
-
-		if (turnoff)
-			*(uint32_t *)(ioasic_base + IOASIC_INTR) = ~turnoff;
-
-		if (intr & KMIN_INTR_TIMEOUT) {
-			kn02ba_errintr();
-			pmax_memerr_evcnt.ev_count++;
+		if ((ipending & MIPS_INT_MASK_0) && intrtab[SYS_DEV_OPT0].ih_func) {
+			(*intrtab[SYS_DEV_OPT0].ih_func)(intrtab[SYS_DEV_OPT0].ih_arg);
+			intrtab[SYS_DEV_OPT0].ih_count.ev_count++;
 		}
 
-		if (intr & KMIN_INTR_CLOCK) {
-			struct clockframe cf;
-
-			__asm volatile("lbu $0,48(%0)" ::
-				"r"(ioasic_base + IOASIC_SLOT_8_START));
-
-			cf.pc = pc;
-			cf.sr = status;
-			hardclock(&cf);
-			pmax_clock_evcnt.ev_count++;
+		if ((ipending & MIPS_INT_MASK_1) && intrtab[SYS_DEV_OPT1].ih_func) {
+			(*intrtab[SYS_DEV_OPT1].ih_func)(intrtab[SYS_DEV_OPT1].ih_arg);
+			intrtab[SYS_DEV_OPT1].ih_count.ev_count++;
 		}
-
-		/* If clock interrupts were enabled, re-enable them ASAP. */
-		if (old_mask & KMIN_INTR_CLOCK) {
-			/* ioctl interrupt mask to splclock and higher */
-			*(uint32_t *)(ioasic_base + IOASIC_IMSK)
-				= old_mask &
-					~(KMIN_INTR_SCC_0|KMIN_INTR_SCC_1 |
-					  IOASIC_INTR_LANCE|IOASIC_INTR_SCSI);
-			kn02ba_wbflush();
-			_splset(MIPS_SR_INT_IE | (status & MIPS_INT_MASK_3));
+		if ((ipending & MIPS_INT_MASK_2) && intrtab[SYS_DEV_OPT2].ih_func) {
+			(*intrtab[SYS_DEV_OPT2].ih_func)(intrtab[SYS_DEV_OPT2].ih_arg);
+			intrtab[SYS_DEV_OPT2].ih_count.ev_count++;
 		}
-
-		if (intr_depth > 1)
-			 goto done;
-
-		CHECKINTR(SYS_DEV_SCC0, IOASIC_INTR_SCC_0);
-		CHECKINTR(SYS_DEV_SCC1, IOASIC_INTR_SCC_1);
-
-#ifdef notyet /* untested */
-		/* If tty interrupts were enabled, re-enable them ASAP. */
-		if ((old_mask & (KMIN_INTR_SCC_1|KMIN_INTR_SCC_0)) ==
-		     (KMIN_INTR_SCC_1|KMIN_INTR_SCC_0)) {
-			*imaskp = old_mask &
-			  ~(KMIN_INTR_SCC_0|KMIN_INTR_SCC_1 |
-			  IOASIC_INTR_LANCE|IOASIC_INTR_SCSI);
-			kn02ba_wbflush();
-		}
-
-		/* XXX until we know about SPLs of TC options. */
-		if (intr_depth > 1)
-			 goto done;
-#endif
-		CHECKINTR(SYS_DEV_LANCE, IOASIC_INTR_LANCE);
-		CHECKINTR(SYS_DEV_SCSI, IOASIC_INTR_SCSI);
-
-		if (user_warned && ((intr & KMIN_INTR_PSWARN) == 0)) {
-			printf("%s\n", "Power supply ok now.");
-			user_warned = 0;
-		}
-		if ((intr & KMIN_INTR_PSWARN) && (user_warned < 3)) {
-			user_warned++;
-			printf("%s\n", "Power supply overheating");
-		}
-	}
-	if ((ipending & MIPS_INT_MASK_0) && intrtab[SYS_DEV_OPT0].ih_func) {
-		(*intrtab[SYS_DEV_OPT0].ih_func)(intrtab[SYS_DEV_OPT0].ih_arg);
-		intrtab[SYS_DEV_OPT0].ih_count.ev_count++;
- 	}
-
-	if ((ipending & MIPS_INT_MASK_1) && intrtab[SYS_DEV_OPT1].ih_func) {
-		(*intrtab[SYS_DEV_OPT1].ih_func)(intrtab[SYS_DEV_OPT1].ih_arg);
-		intrtab[SYS_DEV_OPT1].ih_count.ev_count++;
-	}
-	if ((ipending & MIPS_INT_MASK_2) && intrtab[SYS_DEV_OPT2].ih_func) {
-		(*intrtab[SYS_DEV_OPT2].ih_func)(intrtab[SYS_DEV_OPT2].ih_arg);
-		intrtab[SYS_DEV_OPT2].ih_count.ev_count++;
-	}
-
-done:
+	} while (0);
+
 	/* restore entry state */
-	splhigh();
-	intr_depth--;
 	*(uint32_t *)(ioasic_base + IOASIC_IMSK) = old_mask;
-
-	_splset(MIPS_SR_INT_IE | (status & ~cause & MIPS_HARD_INT_MASK));
 }
 
